`define KEY_SCAN
module vga_exec12(
    clk      ,
    rst_n    ,
    key_col  ,
    key_row  ,
    lcd_hs   ,
    lcd_vs   ,
    seg_sel  ,
    segment  ,      
    led_g    ,
    led_r    ,
    led_y    ,
    lcd_rgb    
    );

    parameter   PICTURE_W = 16  ;
`ifdef KEY_SCAN
    parameter   KEY_W     =  4  ;
`else
    parameter   KEY_W     =  8  ;
`endif

    input                 clk    ;
    input                 rst_n  ;
    input [KEY_W-1:0]     key_col;
    output[3:0]           key_row;
    output                lcd_hs     ;
    output                lcd_vs     ;
    output  [PICTURE_W-1:0] lcd_rgb    ;
    output[3:0]            seg_sel  ;
    output[7:0]            segment  ;
    output                 led_g    ;
    output                 led_r    ;
    output                 led_y    ;
   
/*********www.mdy-edu.com ƽ עͿʼ****************
ģ1 pllģ ӿڶ
**********www.mdy-edu.com ƽ עͽ****************/
wire    clk_0;

/*********www.mdy-edu.com ƽ עͿʼ****************
ģ6 vga ӿڶ
**********www.mdy-edu.com ƽ עͽ****************/ 
parameter       ROW_W  = 10 ; 
wire			        lcd_hs;  	
wire                    lcd_vs;	    
wire	[PICTURE_W-1:0]	lcd_rgb;		
wire    [KEY_W-1:0]     key_col;
wire    [3:0]           key_row;
wire    [3:0]           key_num;
wire                    key_vld;
wire    [KEY_W-1:0]     key_en ;
reg     [KEY_W-1:0]     key_en_temp ;

`ifndef KEY_SCAN
    assign key_row = 0; //ҫ壬ô˹ܽţԶҪ
`endif

 `ifdef KEY_SCAN
    key_scan u_key_scan(
                 .clk    (clk_0  ),
                 .rst_n  (rst_n  ),
                 .key_col(key_col),
                 .key_row(key_row),
                 .key_num(key_num),
                 .key_vld(key_vld)   
               );
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            key_en_temp <= 0;
        end
        else if(key_vld) begin
            key_en_temp[key_num] <= 1'b1;
        end
        else begin
            key_en_temp <= 0;
        end
    end

    assign key_en = key_en_temp;


`else
key_module#(.KEY_W(KEY_W)) u_key_module(
                  .clk    (clk_0  ),
                  .rst_n  (rst_n  ),
                  .key_in (key_col),
                  .key_vld(key_en ) 
    );

`endif


/*********www.mdy-edu.com ƽ עͿʼ****************
ģ1 pllģ 
**********www.mdy-edu.com ƽ עͽ****************/

vga_pll   module_1(
                .inclk0     (clk    ),
                .c0         (clk_0  )
                );

/*********www.mdy-edu.com ƽ עͿʼ****************
ģ6 vga ӿڶ
**********www.mdy-edu.com ƽ עͽ****************/ 

vga_driver module_6(  	
	  .clk(clk_0 )       ,		
	  .rst_n(rst_n)      ,     	
      .key_en(key_en)  ,
	  .hys(lcd_hs)       ,	    
	  .vys(lcd_vs)       ,	    
      .seg_sel(seg_sel)  ,
      .segment(segment)  ,
      .led_g  (led_g  )  ,
      .led_r  (led_r  )  ,
      .led_y  (led_y  )  ,
	  .lcd_rgb(lcd_rgb)   	
);	 

endmodule

